package flm.b4a.gesturedemo;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "flm.b4a.gesturedemo", "flm.b4a.gesturedemo.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "flm.b4a.gesturedemo", "flm.b4a.gesturedemo.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "flm.b4a.gesturedemo.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public flm.b4a.gesturedetector.GestureDetectorForB4A _gd = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlgreen = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlsquare = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
anywheresoftware.b4a.objects.LabelWrapper _lbl = null;
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="Dim lbl As Label";
_lbl = new anywheresoftware.b4a.objects.LabelWrapper();
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="lbl.Initialize(\"\")";
_lbl.Initialize(mostCurrent.activityBA,"");
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="lbl.Text = \"Move the green ball with the finger.\"";
_lbl.setText(BA.ObjectToCharSequence("Move the green ball with the finger."));
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="lbl.TextColor = Colors.White";
_lbl.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="lbl.TextSize = 18";
_lbl.setTextSize((float) (18));
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="Activity.AddView(lbl, 15dip, 15dip, 100%x-30dip,";
mostCurrent._activity.AddView((android.view.View)(_lbl.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (15)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (15)),(int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60)));
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="pnlSquare.Initialize(\"\")";
mostCurrent._pnlsquare.Initialize(mostCurrent.activityBA,"");
RDebugUtils.currentLine=131081;
 //BA.debugLineNum = 131081;BA.debugLine="pnlSquare.Color= Colors.Cyan";
mostCurrent._pnlsquare.setColor(anywheresoftware.b4a.keywords.Common.Colors.Cyan);
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="Activity.AddView(pnlSquare, 0, 0, Activity.Width,";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlsquare.getObject()),(int) (0),(int) (0),mostCurrent._activity.getWidth(),mostCurrent._activity.getWidth());
RDebugUtils.currentLine=131084;
 //BA.debugLineNum = 131084;BA.debugLine="pnlGreen.Initialize(\"\")";
mostCurrent._pnlgreen.Initialize(mostCurrent.activityBA,"");
RDebugUtils.currentLine=131085;
 //BA.debugLineNum = 131085;BA.debugLine="pnlGreen.SetBackgroundImage(LoadBitmap(File.DirAs";
mostCurrent._pnlgreen.SetBackgroundImageNew((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"greenball.png").getObject()));
RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="pnlSquare.AddView(pnlGreen, 30dip, 70dip, 100dip,";
mostCurrent._pnlsquare.AddView((android.view.View)(mostCurrent._pnlgreen.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (70)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)));
RDebugUtils.currentLine=131087;
 //BA.debugLineNum = 131087;BA.debugLine="GD.SetOnGestureListener(pnlGreen, \"Gesture\")";
mostCurrent._gd.SetOnGestureListener(processBA,(android.view.View)(mostCurrent._pnlgreen.getObject()),"Gesture");
RDebugUtils.currentLine=131089;
 //BA.debugLineNum = 131089;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262145;
 //BA.debugLineNum = 262145;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_resume"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null);
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196609;
 //BA.debugLineNum = 196609;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_ondown(float _x,float _y,Object _motionevent) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gesture_ondown"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gesture_ondown", new Object[] {_x,_y,_motionevent});
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub Gesture_onDown(X As Float, Y As Float, MotionE";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="Log(\"   onDown x = \" & X & \", y = \" & Y & \", ev =";
anywheresoftware.b4a.keywords.Common.Log("   onDown x = "+BA.NumberToString(_x)+", y = "+BA.NumberToString(_y)+", ev = "+BA.ObjectToString(_motionevent));
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="Log(\"      pressure = \" & GD.getPressure(MotionEv";
anywheresoftware.b4a.keywords.Common.Log("      pressure = "+BA.NumberToString(mostCurrent._gd.getPressure((android.view.MotionEvent)(_motionevent),(int) (0))));
RDebugUtils.currentLine=393219;
 //BA.debugLineNum = 393219;BA.debugLine="Log(\"      size = \" & GD.getSize(MotionEvent, 0))";
anywheresoftware.b4a.keywords.Common.Log("      size = "+BA.NumberToString(mostCurrent._gd.getSize((android.view.MotionEvent)(_motionevent),(int) (0))));
RDebugUtils.currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_ondrag(float _deltax,float _deltay,Object _motionevent) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gesture_ondrag"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gesture_ondrag", new Object[] {_deltax,_deltay,_motionevent});
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub Gesture_onDrag(deltaX As Float, deltaY As Floa";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="Log(\"   onDrag deltaX = \" & deltaX & \", deltaY =";
anywheresoftware.b4a.keywords.Common.Log("   onDrag deltaX = "+BA.NumberToString(_deltax)+", deltaY = "+BA.NumberToString(_deltay)+", ev = "+BA.ObjectToString(_motionevent));
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="pnlGreen.Left = Max(0, Min(pnlGreen.Left + deltaX";
mostCurrent._pnlgreen.setLeft((int) (anywheresoftware.b4a.keywords.Common.Max(0,anywheresoftware.b4a.keywords.Common.Min(mostCurrent._pnlgreen.getLeft()+_deltax,anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)-mostCurrent._pnlgreen.getWidth()))));
RDebugUtils.currentLine=458755;
 //BA.debugLineNum = 458755;BA.debugLine="pnlGreen.Top = Max(0, Min(pnlGreen.Top + deltaY,";
mostCurrent._pnlgreen.setTop((int) (anywheresoftware.b4a.keywords.Common.Max(0,anywheresoftware.b4a.keywords.Common.Min(mostCurrent._pnlgreen.getTop()+_deltay,anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)-mostCurrent._pnlgreen.getHeight()))));
RDebugUtils.currentLine=458756;
 //BA.debugLineNum = 458756;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onfling(float _velocityx,float _velocityy,Object _motionevent1,Object _motionevent2) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gesture_onfling"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gesture_onfling", new Object[] {_velocityx,_velocityy,_motionevent1,_motionevent2});
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Sub Gesture_onFling(velocityX As Float, velocityY";
RDebugUtils.currentLine=524289;
 //BA.debugLineNum = 524289;BA.debugLine="Log(\"   onFling velocityX = \" & velocityX & \", ve";
anywheresoftware.b4a.keywords.Common.Log("   onFling velocityX = "+BA.NumberToString(_velocityx)+", velocityY = "+BA.NumberToString(_velocityy)+", ev1 = "+BA.ObjectToString(_motionevent1)+", ev2 = "+BA.ObjectToString(_motionevent2));
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onpinchclose(float _newdistance,float _previousdistance,Object _motionevent) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gesture_onpinchclose"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gesture_onpinchclose", new Object[] {_newdistance,_previousdistance,_motionevent});
RDebugUtils.currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Sub Gesture_onPinchClose(NewDistance As Float, Pre";
RDebugUtils.currentLine=786433;
 //BA.debugLineNum = 786433;BA.debugLine="Log(\"   onPinchClose dist=\" & NewDistance & \", pr";
anywheresoftware.b4a.keywords.Common.Log("   onPinchClose dist="+BA.NumberToString(_newdistance)+", prevdist="+BA.NumberToString(_previousdistance)+", ev="+BA.ObjectToString(_motionevent));
RDebugUtils.currentLine=786434;
 //BA.debugLineNum = 786434;BA.debugLine="ResizePanel(MotionEvent, Colors.Red)";
_resizepanel(_motionevent,anywheresoftware.b4a.keywords.Common.Colors.Red);
RDebugUtils.currentLine=786435;
 //BA.debugLineNum = 786435;BA.debugLine="End Sub";
return "";
}
public static String  _resizepanel(Object _motionevent,int _color) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "resizepanel"))
	return (String) Debug.delegate(mostCurrent.activityBA, "resizepanel", new Object[] {_motionevent,_color});
int _left = 0;
int _top = 0;
int _width = 0;
int _height = 0;
RDebugUtils.currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Sub ResizePanel(MotionEvent As Object, Color As In";
RDebugUtils.currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="Dim Left, Top, Width, Height As Int";
_left = 0;
_top = 0;
_width = 0;
_height = 0;
RDebugUtils.currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="If GD.getX(MotionEvent, 0) > GD.getX(MotionEvent,";
if (mostCurrent._gd.getX((android.view.MotionEvent)(_motionevent),(int) (0))>mostCurrent._gd.getX((android.view.MotionEvent)(_motionevent),(int) (1))) { 
RDebugUtils.currentLine=917507;
 //BA.debugLineNum = 917507;BA.debugLine="Left = GD.getX(MotionEvent, 1)";
_left = (int) (mostCurrent._gd.getX((android.view.MotionEvent)(_motionevent),(int) (1)));
 }else {
RDebugUtils.currentLine=917509;
 //BA.debugLineNum = 917509;BA.debugLine="Left = GD.getX(MotionEvent, 0)";
_left = (int) (mostCurrent._gd.getX((android.view.MotionEvent)(_motionevent),(int) (0)));
 };
RDebugUtils.currentLine=917511;
 //BA.debugLineNum = 917511;BA.debugLine="If GD.getY(MotionEvent, 0) > GD.getY(MotionEvent,";
if (mostCurrent._gd.getY((android.view.MotionEvent)(_motionevent),(int) (0))>mostCurrent._gd.getY((android.view.MotionEvent)(_motionevent),(int) (1))) { 
RDebugUtils.currentLine=917512;
 //BA.debugLineNum = 917512;BA.debugLine="Top = GD.getY(MotionEvent, 1)";
_top = (int) (mostCurrent._gd.getY((android.view.MotionEvent)(_motionevent),(int) (1)));
 }else {
RDebugUtils.currentLine=917514;
 //BA.debugLineNum = 917514;BA.debugLine="Top = GD.getY(MotionEvent, 0)";
_top = (int) (mostCurrent._gd.getY((android.view.MotionEvent)(_motionevent),(int) (0)));
 };
RDebugUtils.currentLine=917516;
 //BA.debugLineNum = 917516;BA.debugLine="Width = Abs(GD.getX(MotionEvent, 0) - GD.getX(Mot";
_width = (int) (anywheresoftware.b4a.keywords.Common.Abs(mostCurrent._gd.getX((android.view.MotionEvent)(_motionevent),(int) (0))-mostCurrent._gd.getX((android.view.MotionEvent)(_motionevent),(int) (1))));
RDebugUtils.currentLine=917517;
 //BA.debugLineNum = 917517;BA.debugLine="Height = Abs(GD.getY(MotionEvent, 0) - GD.getY(Mo";
_height = (int) (anywheresoftware.b4a.keywords.Common.Abs(mostCurrent._gd.getY((android.view.MotionEvent)(_motionevent),(int) (0))-mostCurrent._gd.getY((android.view.MotionEvent)(_motionevent),(int) (1))));
RDebugUtils.currentLine=917518;
 //BA.debugLineNum = 917518;BA.debugLine="pnlGreen.SetLayout(Left, Top, Width, Height)";
mostCurrent._pnlgreen.SetLayout(_left,_top,_width,_height);
RDebugUtils.currentLine=917523;
 //BA.debugLineNum = 917523;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onpinchopen(float _newdistance,float _previousdistance,Object _motionevent) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gesture_onpinchopen"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gesture_onpinchopen", new Object[] {_newdistance,_previousdistance,_motionevent});
RDebugUtils.currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Sub Gesture_onPinchOpen(NewDistance As Float, Prev";
RDebugUtils.currentLine=720897;
 //BA.debugLineNum = 720897;BA.debugLine="Log(\"   onPinchOpen dist=\" & NewDistance & \", pre";
anywheresoftware.b4a.keywords.Common.Log("   onPinchOpen dist="+BA.NumberToString(_newdistance)+", prevdist="+BA.NumberToString(_previousdistance)+", ev="+BA.ObjectToString(_motionevent));
RDebugUtils.currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="ResizePanel(MotionEvent, Colors.Green)";
_resizepanel(_motionevent,anywheresoftware.b4a.keywords.Common.Colors.Green);
RDebugUtils.currentLine=720899;
 //BA.debugLineNum = 720899;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onpointerdown(int _ptrindex,int _pid,Object _motionevent) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gesture_onpointerdown"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gesture_onpointerdown", new Object[] {_ptrindex,_pid,_motionevent});
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Sub Gesture_onPointerDown(ptrIndex As Int, PID As";
RDebugUtils.currentLine=589825;
 //BA.debugLineNum = 589825;BA.debugLine="Log(\"onPointerDown ptrindex=\" & ptrIndex & \", pid";
anywheresoftware.b4a.keywords.Common.Log("onPointerDown ptrindex="+BA.NumberToString(_ptrindex)+", pid="+BA.NumberToString(_pid)+", ev="+BA.ObjectToString(_motionevent));
RDebugUtils.currentLine=589827;
 //BA.debugLineNum = 589827;BA.debugLine="pnlGreen.Visible = True";
mostCurrent._pnlgreen.setVisible(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=589828;
 //BA.debugLineNum = 589828;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onpointerup(int _ptrindex,int _pid,Object _motionevent) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gesture_onpointerup"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gesture_onpointerup", new Object[] {_ptrindex,_pid,_motionevent});
RDebugUtils.currentLine=655360;
 //BA.debugLineNum = 655360;BA.debugLine="Sub Gesture_onPointerUp(ptrIndex As Int, PID As In";
RDebugUtils.currentLine=655361;
 //BA.debugLineNum = 655361;BA.debugLine="Log(\"onPointerUp ptrindex=\" & ptrIndex & \", pid=\"";
anywheresoftware.b4a.keywords.Common.Log("onPointerUp ptrindex="+BA.NumberToString(_ptrindex)+", pid="+BA.NumberToString(_pid)+", ev="+BA.ObjectToString(_motionevent));
RDebugUtils.currentLine=655363;
 //BA.debugLineNum = 655363;BA.debugLine="End Sub";
return "";
}
public static String  _gesture_onrotation(double _degrees,Object _motionevent) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gesture_onrotation"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gesture_onrotation", new Object[] {_degrees,_motionevent});
RDebugUtils.currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Sub Gesture_onRotation(Degrees As Double, MotionEv";
RDebugUtils.currentLine=851969;
 //BA.debugLineNum = 851969;BA.debugLine="Log(\"   onRotation degrees=\" & Degrees & \", ev=\"";
anywheresoftware.b4a.keywords.Common.Log("   onRotation degrees="+BA.NumberToString(_degrees)+", ev="+BA.ObjectToString(_motionevent));
RDebugUtils.currentLine=851970;
 //BA.debugLineNum = 851970;BA.debugLine="If pnlGreen.Width > 0 And pnlGreen.Height > 0 The";
if (mostCurrent._pnlgreen.getWidth()>0 && mostCurrent._pnlgreen.getHeight()>0) { 
 };
RDebugUtils.currentLine=851975;
 //BA.debugLineNum = 851975;BA.debugLine="End Sub";
return "";
}
public static boolean  _gesture_ontouch(int _action,float _x,float _y,Object _motionevent) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gesture_ontouch"))
	return (Boolean) Debug.delegate(mostCurrent.activityBA, "gesture_ontouch", new Object[] {_action,_x,_y,_motionevent});
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub Gesture_onTouch(Action As Int, X As Float, Y A";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="Log(\"onTouch action=\" & Action & \", x=\" & X & \",";
anywheresoftware.b4a.keywords.Common.Log("onTouch action="+BA.NumberToString(_action)+", x="+BA.NumberToString(_x)+", y="+BA.NumberToString(_y)+", ev="+BA.ObjectToString(_motionevent));
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="End Sub";
return false;
}
}